package xyz.twokilohertz;

import net.fabricmc.api.ClientModInitializer;
import net.minecraft.class_1657;
import net.minecraft.class_1661;
import net.minecraft.class_1713;
import net.minecraft.class_1750;
import net.minecraft.class_1792;
import net.minecraft.class_310;
import org.lwjgl.glfw.GLFW;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.util.concurrent.Executors;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;

public class HotbarReplace implements ClientModInitializer {
    public static final Logger LOGGER = LoggerFactory.getLogger("hotbarreplace");
    private static final class_310 client = class_310.method_1551();
    private static final ScheduledExecutorService scheduler = Executors.newSingleThreadScheduledExecutor();

    @Override
    public void onInitializeClient() {
        LOGGER.info("HotbarReplace v0.1.3 initialised");
    }

    public static void tryReplaceSlot(class_1750 context, class_1792 item) {
        // Return immediately if player is a spectator
        class_1657 player = context.method_8036();
        if (player.method_7325())
            return;

        // Creative inventories don't run out of blocks anyway
        if (player.method_31549().field_7477)
            return;

        // Get reference to player's current inventory
        class_1661 inventory = player.method_31548();
        if (inventory == null)
            return;

        // Return if the inventory is empty
        if (inventory.method_5442())
            return;

        // If current screen handler is null, return
        if (player.field_7512 == null)
            return;

        // Attempt to find a stack of matching items in the player's inventory
        for (int i = 0; i < player.field_7512.field_7761.size(); i++) {
            if (player.field_7512.field_7761.get(i).method_7677().method_31574(item)) {
                // Simulate moving the stack from one slot to another
                if (client != null) {
                    // TODO: This still feels like a bit of a hack
                    // I honestly do not know Minecraft internals enough to be sure that there won't
                    // be de-sync issues.

                    int current_fps = client.method_47599();
                    int click_delay = Math.round(1.0f / (float) current_fps) * 1000;

                    client.field_1761.method_2906(player.field_7512.field_7763, i, GLFW.GLFW_MOUSE_BUTTON_1,
                            class_1713.field_7790, player);

                    scheduler.schedule(() -> {
                        client.field_1761.method_2906(player.field_7512.field_7763,
                                inventory.method_67532() + class_1661.field_30638, GLFW.GLFW_MOUSE_BUTTON_1,
                                class_1713.field_7790, player);
                    }, click_delay, TimeUnit.MILLISECONDS);
                }

                return;
            }
        }
    }
}
