package xyz.twokilohertz.mixin;

import net.minecraft.class_1269;
import net.minecraft.class_1747;
import net.minecraft.class_1750;
import net.minecraft.class_1792;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfoReturnable;
import xyz.twokilohertz.HotbarReplace;

@Mixin(class_1747.class)
public class BlockItemMixin {
    private class_1792 lastPlacedItem;

    @Inject(at = @At("HEAD"), method = "Lnet/minecraft/item/BlockItem;place(Lnet/minecraft/item/ItemPlacementContext;)Lnet/minecraft/util/ActionResult;")
    private void BlockItem_place_head(class_1750 context, CallbackInfoReturnable<class_1269> info) {
        lastPlacedItem = context.method_8041().method_7909();
    }

    @Inject(at = @At("TAIL"), method = "Lnet/minecraft/item/BlockItem;place(Lnet/minecraft/item/ItemPlacementContext;)Lnet/minecraft/util/ActionResult;")
    private void BlockItem_place_tail(class_1750 context, CallbackInfoReturnable<class_1269> info) {
        // Early return if the block place action would fail
        if (info.getReturnValue() != class_1269.field_5812)
            return;

        // Check if the stack is not empty, return if so
        if (context.method_8041().method_7947() != 0)
            return;

        // Try to replace the hotbar slot
        HotbarReplace.tryReplaceSlot(context, lastPlacedItem);
    }
}
